-- #include "common.lua"

SASSprojectileHandler = {
	shellNum = 1,
	shells = {},
	defaultShell = {active = false}
}
muzzleflash = LoadSprite("gfx/glare.png")
function init()
	RegisterTool("supersass", "SASS", "MOD/vox/sass.vox")
	SetBool("game.tool.supersass.enabled", true)
	SetFloat("game.tool.supersass.ammo", 12000)

	damage = 1.1
	gravity = Vec(0, -9.81, 0)
	velocity = 600
	reloadTime = 2.4
	shotDelay = 0.07
	shotDelayDecrement = shotDelay/10 --10%
	shotDecrements = 0 
	shotDecrementInterval = shotDelay*1.4
	
	ammo = 80
	unlimitedammo = GetBool("savegame.mod.unlimitedammo")
	moreAmmo = GetBool("savegame.mod.moreammo")
	if moreAmmo then
		ammo = 160
	end

	leftHanded = false --todo: lefthand support
	zoomsense = 15000
	zoomlevel = 5
	maxzoom = 7
	minzoom = 0.5
	SASS_iszoomed = false
	scopeEnableKey = "X" --if you want to grab smth
	scopeEnabled = true
	chargeStacksMax = 4
	chargeStacks = math.min(0,chargeStacksMax)
	chargeActiveKey = "V" --use the charged shot
	charged = false
	lastShotTrans = Transform()
	lastAimPos = Vec()
	
	followUp = false --followup shots to a charged shot
	followUpKey = "C"
	followUpShots = 4
	followUpShotCounter = 0

	for i=1, 40 do
		SASSprojectileHandler.shells[i] = deepcopy(SASSprojectileHandler.defaultShell)
	end

	shootTimer = 0
	reloadTimer = 0
	recoilTimer = 0
	recoilDelay = 0.25 --separated from shotDelay
	lightTimer = 0
	spreadTimer = 0 
	chargeTimer = 0 --timer for charge

	gunsound = LoadSound("MOD/snd/suppress_shot.ogg")
	cocksound = LoadSound("MOD/snd/awp_cock.ogg")
	dryfiresound = LoadSound("MOD/snd/dryfire.ogg")
	zoomsound = LoadSound("MOD/snd/awp_zoom.ogg")
	beepsound = LoadSound("MOD/snd/peeb.ogg")
	creepysound = LoadSound("MOD/snd/reverb.ogg")
	chargenotice = LoadSound("clickup.ogg")

end

function deepcopy(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in next, orig, nil do
            copy[deepcopy(orig_key)] = deepcopy(orig_value)
        end
        setmetatable(copy, deepcopy(getmetatable(orig)))
    else
        copy = orig
    end
    return copy
end

function clamp(value, mi, ma)
	if value < mi then value = mi end
	if value > ma then value = ma end
	return value
end

function orientation(transform, sign)
	local fwd = VecNormalize(VecSub(TransformToParentPoint(transform, Vec(0, 0, -5)), transform.pos))
	local dir = Vec(0, 1*sign, 0)
	local orientationFactor = clamp(VecDot(dir, fwd) * 0.7 + 0.3, 0.0, 1.0)
	return orientationFactor
end
function canShoot() --no shooting in the car or computer screen
	if GetPlayerScreen() == 0 and GetPlayerVehicle() == 0 then
		return true
	end
	return false
end

function canUseTool() --because scoping disables the getbool
	if GetPlayerScreen() == 0 and GetPlayerVehicle() == 0 and GetPlayerGrabShape() == 0 then
		return true
	end
	return false
end

function GetAimPos()
	local ct = GetCameraTransform()
	local forwardPos = TransformToParentPoint(ct, Vec(0, 0, -150))
    local direction = VecSub(forwardPos, ct.pos)
    local distance = VecLength(direction)
	local direction = VecNormalize(direction)
	local hit, hitDistance = QueryRaycast(ct.pos, direction, distance)
	if hit then
		forwardPos = TransformToParentPoint(ct, Vec(0, 0, -hitDistance))
		distance = hitDistance
	end
	return forwardPos, hit, distance
end
function muzzleFlash() --set up the muzzleflash particle
	ParticleReset()
	ParticleType("plain")
	ParticleTile(0)
	ParticleColor(0.8,0.65,0.5)
	ParticleRadius(0.1,0.05)
	ParticleAlpha(1,1,"constant")
	ParticleEmissive(2,0.3)
	ParticleStretch(1)
	ParticleSticky(0)
	ParticleCollide(0)
end

function Shoot(mode)
	if shootTimer > 0 or ammo == 0 then
		return
	end

	local ct = GetCameraTransform()
	aimpos, hit, distance = GetAimPos()

	local direction = VecSub(aimpos, toolPos)
	local direction2 = VecSub(aimpos, GetCameraTransform().pos)
	local muzzletrans = Transform(toolPos,QuatCopy(toolTrans.rot))
	local origin = toolPos
	
	if mode == "followup" then
		direction = VecSub(lastAimPos, lastShotTrans.pos)
		muzzletrans = lastShotTrans
		origin = lastShotTrans.pos
	end

	SASSprojectileHandler.shells[SASSprojectileHandler.shellNum] = deepcopy(SASSprojectileHandler.defaultShell)
	loadedShell = SASSprojectileHandler.shells[SASSprojectileHandler.shellNum] 
	loadedShell.active = true
	
	--spread
	dirtrans = Transform(origin,QuatLookAt(origin, aimpos))
	
	if mode == "followup" then
		dirtrans.rot =  QuatLookAt(origin, lastAimPos)
	end
	
	local spread = math.min(spreadTimer,1) * distance*10/100
	local dirspread = (math.random()-0.5)*spread
	local dirspread2 = (math.random()-0.5)*spread
	dirspread = TransformToParentVec(dirtrans,Vec(dirspread,dirspread2,0))
	direction = VecAdd(direction,dirspread)

	loadedShell.pos = origin
	loadedShell.origPos = origin
	loadedShell.predictedBulletVelocity = VecScale(direction, (velocity/distance))
	loadedShell.grazeStart = 4
	loadedShell.travelDist = 0
	loadedShell.damage = damage
	loadedShell.physmult = 1
	loadedShell.super = false --charged shot
	if mode == "charged" then
		loadedShell.super = true
		chargeTimer = 11
		if followup then chargeTimer = 15 end
		lastShotTrans = Transform(muzzletrans.pos,muzzletrans.rot)
		lastAimPos = aimpos
	elseif mode == "followup" then
		loadedShell.damage = 2.3
		loadedShell.physmult = 2.5
	end
	if loadedShell.super then
		loadedShell.damage = 4 --stupid max size hole limit
		loadedShell.physmult = 4
	end

	SASSprojectileHandler.shellNum = (SASSprojectileHandler.shellNum%#SASSprojectileHandler.shells) +1

	SpawnParticle(origin,TransformToParentVec(muzzletrans,Vec(0,0,-20)),0.1)
	--SpawnParticle("fire", origin, Vec(0, 1.0+math.random(1,10)*0.1, 0), 0.4, 0.15)
	--SpawnParticle("darksmoke", origin, Vec(0, 1.0+math.random(1,10)*0.1, 0), 0.25, 0.8)
	DrawSprite(muzzleflash,{pos=origin,rot=ct.rot},10,10,0.4,0.4,1,1,false,true)
	PlaySound(gunsound, origin, 3, false) --bang

	if not unlimitedammo then
		ammo = ammo - 1
	end
	if mode == "followup" then
		followUpShotCounter = followUpShotCounter - 1
	end
	
	shootTimer = clamp(shotDelay-shotDelayDecrement*shotDecrements, 0.03, shotDelay)
	if mode ~= "followup" then
		recoilTimer = recoilDelay
	elseif mode == "charged" then
		recoilTimer = recoilDelay*2
	end
	spreadTimer = spreadTimer + 0.23
	PointLight(origin, 0.3, 0.4, 1, 0.7) --muzzle flashes are instant right?
	
	--for followup shots
	if mode == "charged" and followUp then
		followUpShotCounter = followUpShots
	end
end

function ProjectileOperations(projectile)
	projectile.predictedBulletVelocity = VecAdd(projectile.predictedBulletVelocity, (VecScale(gravity, GetTimeStep())))
	local point2 = VecAdd(projectile.pos, VecScale(projectile.predictedBulletVelocity, GetTimeStep()))
	local dir = VecNormalize(VecSub(point2, projectile.pos))
	local axis = Transform(projectile.pos,QuatLookAt(projectile.pos,point2)) --axis of bullet direction
	local physicsMult = projectile.physmult --hate dots
	
	QueryRequire("physical")
	local hit, dist = QueryRaycast(projectile.pos, dir, VecLength(VecSub(point2, projectile.pos)))
	
	if hit then
		hitPos = VecAdd(projectile.pos, VecScale(dir, dist))
		projectile.active = false
		if projectile.super then PlaySound(creepysound,hitPos,40, true) end
		projectile.travelDist = projectile.travelDist + dist
		SpawnParticle("smoke", hitPos, Vec(0, 1.0+math.random(1,10)*0.1, 0), projectile.damage, 1)
		local dmg = projectile.damage
		if VecLength(VecSub(hitPos,GetPlayerCameraTransform().pos)) > projectile.damage then--holing
			MakeHole(hitPos, projectile.damage, projectile.damage*0.9, 0)
		end
		--GRAZE
		axis.pos = hitPos
		--bodies in holing distance
		QueryRequire("physical") --dynamic optional
		local mi = VecAdd(hitPos,Vec(-dmg*1.5,-dmg*1.5,-dmg*1.5))
		local ma = VecAdd(hitPos,Vec(dmg*1.5,dmg*1.5,dmg*1.5))
		local bodies = QueryAabbBodies(mi, ma)	
		--loop through bodies
		for i,body in ipairs(bodies) do
			--compute body center and dist
			local bmi,bma = GetBodyBounds(body)
			local bc = VecLerp(bmi,bma,0.5) --get center
			local dir = VecSub(bc, hitPos)
			local dist = VecLength(dir)
			dir = VecScale(dir,1/dist)
			local mass = GetBodyMass(body)--get mass
			
			--dir forward
			dir = VecLerp(dir,projectile.predictedBulletVelocity,1)
			dir = VecNormalize(dir)
			
			local massScale = 1 - math.min(mass/(170*physicsMult),1)
			local distScale = 1 - math.min(dist/dmg*1.2,1)
			--local force = math.min(15000*massScale*distScale,200*mass*massScale*distScale)
			local force = (600*mass*massScale*distScale)
			local add = VecScale(dir,force)
			
			ApplyBodyImpulse(body,bc,add)
		end
	else
		DrawLine(projectile.pos, point2)
	end
	
	projectile.travelDist = projectile.travelDist + VecLength(VecScale(projectile.predictedBulletVelocity, GetTimeStep()))
    projectile.pos = point2
end

function Zoom()
	SASS_iszoomed = not SASS_iszoomed
	PlaySound(zoomsound, GetPlayerTransform().pos, 0.5, false)
end


function tick(dt)
	if SASS_iszoomed then
		SetString("game.player.tool", "supersass")
	end

	if followUpShotCounter > 0 then
		Shoot("followup")
	end

	if GetString("game.player.tool") == "supersass" and canShoot() then
		if InputPressed("esc") then SASS_iszoomed = false end

		if InputPressed("lmb") and ammo > 0 and canUseTool() then
			firing = true
		else
			firing = false
		end
		

		if InputPressed("lmb") and canUseTool() then
			if ammo == 0 then
				PlaySound(dryfiresound, GetPlayerTransform().pos, 1, false)
			end
		end

		if firing then
			if not charged then
				Shoot()
			else
				Shoot("charged")
			end
		end
		
		if InputPressed(scopeEnableKey) then 
			scopeEnabled = not scopeEnabled 
			if SASS_iszoomed then Zoom() end
		end
		
		if InputPressed(chargeActiveKey) then
			if chargeTimer <= 0 then
				charged = not charged
				PlaySound(beepsound, GetPlayerTransform().pos, 1, false)
			end
		end
		
		if InputPressed(followUpKey) then
			followUp = not followUp
		end
		
		if InputPressed("rmb") and scopeEnabled then Zoom() end
		
		local b = GetToolBody()
		local s = GetBodyShapes(b)[1] --gun is a single piece vox
		if b ~= 0 then
			local heightOffset = InputDown("ctrl") and 0.125 or 0
			local offset = Transform(Vec(0, heightOffset, 0))
			if inspect then offset.rot = QuatEuler(40,-40,65) 
				offset.pos = VecAdd(offset.pos, Vec(-0.45,-0.7,0))
			end
			
			SetToolTransform(offset,0.75)
			toolTrans = GetBodyTransform(b)
			toolPos = TransformToParentPoint(toolTrans, Vec(0.275, -0.275, -2.15))
			local sTrans = GetShapeWorldTransform(s)

			if recoilTimer > 0 then
				local t = Transform()
				if not blowback then blowback = 0 end
				if blowback < recoilTimer*2 then
					blowback = blowback+(recoilTimer*10-blowback)*dt
				else
					blowback = recoilTimer*2
				end
				t.pos = Vec(0, heightOffset, blowback)
				t.rot = QuatEuler(blowback*10, 0, 0)
				SetToolTransform(t,0.9)

				recoilTimer = recoilTimer - dt
			end
		
		end

		if SASS_iszoomed and scopeEnabled then
			toolPos = GetPlayerCameraTransform().pos
			local mousewheel = InputValue("mousewheel")
			if mousewheel ~= 0 then
				zoomlevel = clamp(zoomlevel - mousewheel/2, minzoom, maxzoom)
			end

			local pvel = GetPlayerVelocity()
			local mx, my = InputValue("mousedx"), -InputValue("mousedy")
	
			local ct = GetCameraTransform()
			local pt = GetPlayerTransform()
			
			local upAngle = orientation(Transform(pt.pos, ct.rot), 1)
			local downAngle = orientation(Transform(pt.pos, ct.rot), -1)
			if ((upAngle > 0.98 and my > 0) or (downAngle > 0.98 and my < 0)) then
			  my = 0
			end
	
			pt.pos[2] = pt.pos[2] + 1.8
			local target = Vec(mx/(zoomsense/zoomlevel), my/(zoomsense/zoomlevel), -1)
			target = TransformToParentVec(ct, target)
			ct.rot = QuatLookAt(ct, target)
	
			SetCameraTransform(Transform(pt.pos, ct.rot), zoomlevel*10)
			SetPlayerTransform(Transform(GetPlayerTransform().pos, ct.rot))
	
			SetPlayerVelocity(pvel)
		end
	
		if shootTimer > 0 or ammo == 0 then
			shootTimer = shootTimer - dt
		end
		
		if ammo <= 0 then
			followUpShotCounter = 0
		end
	end
	
	--timers and stuff to stay active if tool is unequipped
	spreadTimer = math.max(spreadTimer - dt,0)	
	if chargeTimer > 0 then
			charged = false
			chargeTimer = chargeTimer - dt
		end
	for key, shell in ipairs(SASSprojectileHandler.shells) do
		if shell.active then
			ProjectileOperations(shell)
		end
	end
end

function draw()
	if GetString("game.player.tool") == "supersass" and canShoot() then
		if SASS_iszoomed and scopeEnabled then
			UiPush()
				UiTranslate(UiCenter(), UiMiddle())
				UiAlign("center middle")
				UiImage("MOD/img/awpscope.png")
			UiPop()
		end

		if not unlimitedammo then
			UiPush()
				UiTranslate(UiCenter(), UiHeight()-60)
				UiAlign("center middle")
				UiColor(1, 1, 1)
				UiFont("bold.ttf", 32)
				UiTextOutline(0,0,0,1,0.1)
				UiText(ammo)

			UiPop()
		end

		UiPush()
			UiTranslate(UiCenter()/5, UiHeight()*0.9)
			UiAlign("center middle")
			UiColor(1, 1, 1)
			UiFont("bold.ttf", 24)
			UiTextOutline(0,0,0,1,0.1)
			if scopeEnabled then
				UiText("["..scopeEnableKey.."] Scope enabled")
			else
				UiText("["..scopeEnableKey.."] Scope disabled")
			end
			UiTranslate(0, -33)
		UiPop()
		
		UiPush()
			UiTranslate(UiCenter()/5, UiHeight()*0.925)
			UiAlign("center middle")
			UiColor(1, 1, 1)
			UiFont("bold.ttf", 24)
			UiTextOutline(0,0,0,1,0.1)
			if chargeTimer <=0 then
				if charged then 
					UiColor(1,0.1,0)
				else
					UiColor(0.5,0.4,1)
				end
				UiText("["..chargeActiveKey.."] CHARGED")
			else
				UiText("["..chargeActiveKey.."] Not ready")
			end
			UiTranslate(115,0)
			UiAlign ("left")
			UiColor(1,0.6,0.2)
			if not followUp then UiText("["..followUpKey.."] Follow-up shots disabled")
			else
				UiColor(1,0.4,0)
				UiText("["..followUpKey.."] Follow-up charged shots enabled")
			end
		UiPop()
	end
end